

local basic_assets =
{
	Asset("ANIM", "anim/situyl_claw.zip"),
	Asset("ANIM", "anim/situyl_claw_swap.zip"),
	Asset("ANIM", "anim/ui_situyl_claw_1x1.zip"),
	Asset("ATLAS", "images/situyl_claw.xml"),
	
	--Ч
	--Asset("SOUNDPACKAGE", "sound/situyl_zoom.fev"),
    --Asset("SOUND", "sound/situyl_zoom.fsb"),
}

local slotpos = {Vector3(-80, -80,0)}
local function itemtest(inst, item, slot)
	return item.prefab ~= inst.prefab and item.prefab ~= "jellyfish"
end
--[[
for y = 2, 0, -1 do
	for x = 0, 2 do
		table.insert(slotpos, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
	end
end]]

local function onfinished(inst)
	inst.components.container:DropEverything()
	----ʧ
	if inst.arm then
		inst.arm:Remove()
		inst.arm = nil
	end
	----һӻ
	if GetPlayer().components.talker then
		GetPlayer().components.talker:Say( tw__ischstr("Ǹצ", "That claw has been broken") )
	end
	
	inst:Remove()
end

local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_object", "situyl_claw_swap", "situyl_claw_swap")
	owner.AnimState:Show("ARM_carry")
	owner.AnimState:Hide("ARM_normal")
	
	--Ϊ˱֤ʱǿŵ
	inst:DoTaskInTime(0, function()
		inst.components.container:Open(owner)
	end)
	
end

local function onunequip(inst, owner)
	owner.AnimState:Hide("ARM_carry")
	owner.AnimState:Show("ARM_normal")
	inst.components.container:Close(owner)
end

local function basicattack(inst, attacker, target)
	tw_spawn(target, "impact", nil, target.components.combat.hiteffectsymbol, 2.5, {inst:GetPosition()})
end

local function OnCaught(inst, catcher)
    if catcher then
        if catcher.components.inventory then
            if inst.components.equippable and not catcher.components.inventory:GetEquippedItem(inst.components.equippable.equipslot) then
				catcher.components.inventory:Equip(inst)
			else
                catcher.components.inventory:GiveItem(inst)
            end
			
			----ʧ
			if inst.arm then
				inst.arm:Remove()
				inst.arm = nil
			end
			
			----סڵĶ
            --catcher:PushEvent("catch")
			
			----ͷűץ
			if inst.caught_ent then
				tw_startbrain_by_claw(inst.caught_ent)
				inst.caught_ent.entity:SetParent(nil)
				inst.caught_ent.Transform:SetPosition(inst.Transform:GetWorldPosition())
				if tw_isalive(inst.caught_ent) and inst.caught_ent.components.combat and not inst.caught_ent.components.combat:IsAlly(catcher) then
					inst.caught_ent.components.combat:SuggestTarget(catcher)
				end
				inst.caught_ent = nil
			end
			----
			
			----ȡ¼
			if inst.is_different_terrian_task ~= nil then
				inst.is_different_terrian_task:Cancel()
				inst.is_different_terrian_task = nil
			end
			
			----ͷץȡӻ
			if inst.caught_chest then
				inst.caught_chest.entity:SetParent(nil)
				
				--ȡ˵λ
				local x,y,z = inst.Transform:GetWorldPosition()
				--0.5Ϊ
				local x2,y2,z2 = math.floor(x)+.5, 0, math.floor(z)+.5
				--
				inst.caught_chest.Transform:SetPosition(x2,0,z2)
				--ͣ
				if inst.caught_chest.Physics then inst.caught_chest.Physics:Stop() end
				
				----Աװ----
				if inst.caught_chest.components.equippable and not catcher.components.inventory:GetEquippedItem(inst.caught_chest.components.equippable.equipslot) then
					catcher.components.inventory:Equip(inst.caught_chest)
				end
				
				----צԱװƷ
				local slot0
				if inst.caught_chest.prefab == "situyl_claw" then
					slot0 = catcher.components.inventory:GetNextAvailableSlot(inst.caught_chest)
					if slot0 then
						catcher.components.inventory:GiveItem(inst.caught_chest, nil, Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
					end
				end
				
				----ݱ----
				if inst.caught_chest.prefab == "tumbleweed" then
					inst.caught_chest.components.pickable:Pick(catcher)
				end
				
				inst.caught_chest = nil
			end
			
			----Ʒӵ
			local item = inst.components.container.slots[1]
			local slot
			--жϻ, ץǰͬһprefabҪע
			if item and item.prefab ~= inst.prefab and item.prefab ~= "butterfly" then
				slot = catcher.components.inventory:GetNextAvailableSlot(item)
				if slot then
					inst.components.container:DropItem_situyl_claw(item, true)
					catcher.components.inventory:GiveItem(item, nil, Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
				end
			end
			
        end
    end
end

local function ReturnToOwner(inst, owner)
    if owner and not (inst.components.finiteuses and inst.components.finiteuses:GetUses() < 1) then
        owner.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_return")
        inst.components.projectile:Throw(owner, owner)
    end
end

local function OnHit(inst, owner, target)
	local can_ReturnToOwner = false
    if owner == target then
		--OnCaught(inst, owner)
    else
		can_ReturnToOwner = true
    end
    --tw_spawn(target, "impact", nil, target.components.combat and target.components.combat.hiteffectsymbol, 2.5, {inst:GetPosition()})
	tw_spawn(target, "impact", nil, nil, 2.5, {inst:GetPosition()})
	
	--;1
	inst.components.finiteuses:Use(1)
	
	if owner and not (inst.components.finiteuses and inst.components.finiteuses:GetUses() < 1) then
	
		--ǿ򵹳е
		if not inst.components.container:IsEmpty() then
			inst.components.container:DropEverything()
		
		--յܲ׽
		else
			----׽--------------------------
			if tw_isalive(target) and not ( target:HasTag("wall") or string.find(target.prefab, "wall") or string.find(target.prefab, "pillar") or string.find(target.prefab, "den") ) then
			
				--ʼ
				inst.lootprefabs = {}
			
				--ͨ׽
				if target.components.inventoryitem then
					
					----ˮϺŸ
					if target.prefab == "seagull_water" then
						inst.components.container:GiveItem(SpawnPrefab("seagull"))
						target:Remove()
					----
					else
						inst.components.container:GiveItem(target)
					end
					
				--׽
				elseif target.components.lootdropper and target:HasTag("canbetrapped") then
					inst.lootprefabs = target.components.lootdropper:GenerateLoot()
					local situyl_zoom = target.components.situyl_zoom
					if situyl_zoom then
						local moreloot = situyl_zoom.tab[situyl_zoom.current]["loot"] - 1
						if moreloot > 0 then
							for k = 1, moreloot do
								for i,j in pairs( target.components.lootdropper:GenerateLoot() ) do
									table.insert(inst.lootprefabs, j)
								end
							end
						end
					end
					target:Remove()
					
				----ѲܱĿƶﹴ
				elseif target.components.locomotor then
					
					--ȹһ, ȻΪĹ(ѲѪ)
					if not owner.components.combat:IsAlly(target) then
						target.components.combat:GetAttacked(inst, 20)
					end
					
					--ǣ
					if not target.stopbrain_by_claw and tw_isalive(target) then
						
						--ͨβץ
						if tw_iscontinuous(target, 3, nil, owner) then
							--ǣ
							tw_stopbrain_by_claw(target)
							target.entity:SetParent(inst.entity)
							target.Transform:SetPosition(0,0,0)
							
							inst.caught_ent = target
						
							--ʱ,ʱص
							if inst.is_different_terrian_task == nil then
								inst.is_different_terrian_task = inst:DoPeriodicTask(1/30, function()		--DoTaskInTime --DoPeriodicTask
									
									if inst.caught_ent then
										--βͨ  ͷץȡ
										if not tw_iscontinuous(inst.caught_ent, 3, nil, owner) or not tw_isalive(inst.caught_ent) then
											tw_startbrain_by_claw(inst.caught_ent)
											inst.caught_ent.entity:SetParent(nil)
											inst.caught_ent.Transform:SetPosition(inst.Transform:GetWorldPosition())
											
											if tw_isalive(inst.caught_ent) and inst.caught_ent.components.combat and not inst.caught_ent.components.combat:IsAlly(owner) then
												inst.caught_ent.components.combat:SuggestTarget(owner)
											end
											
											inst.caught_ent = nil
										end
										----
									end
									
								end)
							end
							----
						end
						
					end
				
				--elseif target:HasTag("wall") or string.find(target.prefab, "wall") then
					
					
				end
				
				--лЩ
				if #(inst.lootprefabs) > 0 then
					for k,v in ipairs(inst.lootprefabs) do
						local loot = SpawnPrefab(v)
						if loot then
							inst.components.container:GiveItem(loot)
						end
					end
				end	
				
				inst.lootprefabs = {}
				
			----ץȡƷ
			elseif target.components.inventoryitem then
				if target.components.inventoryitem.cangoincontainer then
					--צ
					if target.prefab == inst.prefab then
						target.entity:SetParent(inst.entity)
						target.Transform:SetPosition(0,0,0)
						inst.caught_chest = target
					else
						inst.components.container:GiveItem(target)
					end
				else	
					--ǣ, 米
					target.entity:SetParent(inst.entity)
					target.Transform:SetPosition(0,0,0)
					inst.caught_chest = target
				end
				
			----ɼԴ
			elseif target.components.pickable and target.components.pickable.canbepicked and target.prefab ~= "tumbleweed" then
				--µĵpick
				target.components.pickable:Pick_situyl_claw(inst)
			
			----ջԴharvest
			elseif target.components.harvest and target.components.harvest:CanBeHarvested() then
				target.components.harvest:Harvest_situyl_claw(inst)
			elseif target.components.crop and (target.components.crop.matured or target.components.crop.withered) then
				target.components.crop:Harvest_situyl_claw(inst)
			elseif target.components.stewer and target.components.stewer.done then
				target.components.stewer:Harvest_situyl_claw(inst)
			elseif target.components.dryer and target.components.dryer:IsDone() then
				target.components.dryer:Harvest_situyl_claw(inst)
			elseif target.components.occupiable and target.components.occupiable:IsOccupied() then
				local item = target.components.occupiable:Harvest()
				if item then
					inst.components.container:GiveItem(item)
				end
			
			----ץȡ
			elseif target.components.container and not target.components.health and string.find(target.prefab, "chest") and not target.components.drivable or 
				target.prefab == "tumbleweed" 
				then
				--ǣ
				target.entity:SetParent(inst.entity)
				target.Transform:SetPosition(0,0,0)
				inst.caught_chest = target
				
			----ץȡؾ
			elseif target.components.drivable and target.components.drivable.driver == nil and target.components.drivable:CanDrive(owner) then
				
				local driver = owner.components.driver
				if driver then
					--, Ϊ˹ȥ
					can_ReturnToOwner = false
					inst.AnimState:PlayAnimation("idle")
					
					--Ѿڴ, 
					if driver.vehicle then
						driver:OnDismount()
					end 
					
					--ϴ
					driver:OnMount(target) 
					target.components.drivable:OnMounted(owner)
					
					--ջعצ
					OnCaught(inst, owner)
				end
					
				
			----ץȡؾ, Լȥ, ,ľ,ʯ
			elseif target:HasTag("structure") or target:HasTag("tree") or string.find(target.prefab, "rock") or string.find(target.prefab, "reef") or target:HasTag("wall") or
					string.find(target.prefab, "wall") or string.find(target.prefab, "den") or string.find(target.prefab, "bush") or string.find(target.prefab, "pillar") or
					string.find(target.prefab, "basalt") or string.find(target.prefab, "statue") or string.find(target.prefab, "tree") or string.find(target.prefab, "barrel") or
					target.prefab == "firesuppressor" or target.prefab == "sandbag" or target.prefab == "telebase" or target.prefab == "gemsocket" or 
					string.find(target.prefab, "nest")
				then
			
				local driver = owner.components.driver
				
				--ûؾϵͳ  ؾ
				if not driver or driver.vehicle == nil then
					if tw_isonland(target) then
						--, Ϊ˹ȥ
						can_ReturnToOwner = false
						inst.AnimState:PlayAnimation("idle")
						--˹ȥ--------------------------------------------
						local x,y,z = inst.Transform:GetWorldPosition()
						owner.Transform:SetPosition(x,0,z)
						------------------------------------------------------
						--ջعצ
						OnCaught(inst, owner)
					end
					
				--ؾϵͳ
				else
					--ڴ
					if driver.vehicle then
						--Ŀˮ, ˴ȥ
						if not tw_isonland(target) then
						
							can_ReturnToOwner = false
							inst.AnimState:PlayAnimation("idle")
							--˹ȥ--------------------------------------------
							local x,y,z = inst.Transform:GetWorldPosition()
							owner.Transform:SetPosition(x,0,z)
							------------------------------------------------------
							--ջعצ
							OnCaught(inst, owner)
							
						--Ŀ½, ´Լȥ
						else
							--, Ϊ˹ȥ
							can_ReturnToOwner = false
							inst.AnimState:PlayAnimation("idle")
							
							--Ѿڴ, 
							if driver.vehicle then
								driver:OnDismount()
							end 
							
							--˹ȥ--------------------------------------------
							local x,y,z = inst.Transform:GetWorldPosition()
							owner.Transform:SetPosition(x,0,z)
							------------------------------------------------------
							
							--ջعצ
							OnCaught(inst, owner)
						end
					
					end
				
				end
				
			
			end
		
		end
	
		if can_ReturnToOwner == true then
			ReturnToOwner(inst, owner)
		end
		
	end
	---------------------
end

local function OnThrown(inst, owner, target)
    if target ~= owner then
        owner.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_throw")
		--ɳȥıʳ
		if owner.components.hunger then owner.components.hunger:DoDelta(-1, false) end
		--ɳȥ
		
		if not inst.arm then
            
	        inst.arm = SpawnPrefab("situyl_claw_rope")
			
			inst:DoTaskInTime(.1, function() inst.arm.AnimState:PlayAnimation("idle", true) end)
			
			inst.arm:DoPeriodicTask(1/30, function()
				local x,y,z = owner.Transform:GetWorldPosition() 
				inst.arm.Transform:SetPosition(x, inst.arm.offset_y or 0, z)
			end)
			
	        inst.arm:FacePoint(Vector3(inst.Transform:GetWorldPosition() ) )
	        inst.arm.components.stretcher:SetStretchTarget(inst)
	        
        end
		
    end
    inst.AnimState:PlayAnimation("spin", true)
end


local function cantornado(staff, caster, target, pos)
    return target and not target:HasTag("shadowcreature") and not target:HasTag("FX") and not target:HasTag("fx")
end

local function spawntornado(staff, target, pos) 
	
	local owner = staff.components.inventoryitem.owner
	
	owner.components.inventory:DropItem(staff, false, nil, nil, true) 
	staff.components.projectile:Throw(owner, target)
	
end

local function commonfn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	--MakeInventoryPhysics(inst)
	inst.entity:AddPhysics()
    inst.Physics:SetSphere(.5)
    inst.Physics:SetMass(1)
    inst.Physics:SetFriction(.1)
    inst.Physics:SetDamping(0)
    inst.Physics:SetRestitution(.5)
    inst.Physics:SetCollisionGroup(COLLISION.ITEMS)
    inst.Physics:ClearCollisionMask()
    inst.Physics:CollidesWith(COLLISION.GROUND) --inst.Physics:CollidesWith(COLLISION.WORLD) [dg] Trying this
    inst.Physics:CollidesWith(COLLISION.OBSTACLES)
	
	--MakeInventoryFloatable(inst, "idle_water", "idle")

	inst:AddTag("sharp")
	inst:AddTag("projectile")
	inst:AddTag("situyl_claw")
	inst:AddTag("nopunch")

	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(50)
	inst.components.finiteuses:SetUses(50)

	inst.components.finiteuses:SetOnFinished( onfinished )
	
	inst:AddComponent("container")
	inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_icepack_2x3"
    inst.components.container.widgetanimbuild = "ui_situyl_claw_1x1"
    inst.components.container.widgetpos = Vector3(-5-160,-50,0)
    inst.components.container.side_widget = true
    inst.components.container.type = "situyl_claw"

	inst:AddComponent("inspectable")

	--Ҽץȡ
	inst:AddComponent("spellcaster_situyl_claw")
	inst.components.spellcaster_situyl_claw.canuseontargets = true
	inst.components.spellcaster_situyl_claw.canusefrominventory = false
	inst.components.spellcaster_situyl_claw:SetSpellTestFn(cantornado)
	inst.components.spellcaster_situyl_claw:SetSpellFn(spawntornado)

	return inst
end

--צ
local function basicfn(Sim)
	local inst = commonfn(Sim)

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/situyl_claw.xml"
	inst.components.inventoryitem.imagename = "situyl_claw"

	inst.AnimState:SetBuild("situyl_claw")
	inst.AnimState:SetBank("situyl_claw")
	inst.AnimState:PlayAnimation("idle")

	if IsDLCEnabled(CAPY_DLC) then
		inst:AddComponent("floatable")
		inst.components.floatable.landanim = "idle" 
		inst.components.floatable.wateranim = "idle" 
	end
	
	inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(25)
    inst.components.projectile:SetCanCatch(true)
    inst.components.projectile:SetOnThrownFn(OnThrown)
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(ReturnToOwner)
    inst.components.projectile:SetOnCaughtFn(OnCaught)
    inst.components.projectile:SetLaunchOffset(Vector3(0, 0.2, 0))
	--inst.components.projectile.hitdist = .5
	
	--ʵ崦˯ʱԶ
	--[[
	inst.OnEntitySleep = function(inst)
		local catcher = GetPlayer()
		OnCaught(inst, catcher)
	end]]
	
	--д
	function inst.components.projectile:Hit(target)
		local attacker = self.owner
		--local weapon = self.inst
		self:Stop()
		self.inst.Physics:Stop()
		--if not attacker.components.combat and attacker.components.weapon and attacker.components.inventoryitem then
		--	weapon = attacker
		--	attacker = weapon.components.inventoryitem.owner
		--end
		
		if self.onhit then
			self.onhit(self.inst, attacker, target)
		end
	end
	
	function inst.components.projectile:Throw(owner, target, attacker)
		self.owner = owner
		self.target = target
		self.start = Vector3(owner.Transform:GetWorldPosition() )
		self.dest = Vector3(target.Transform:GetWorldPosition() )

		local offset = self.launchoffset
		print('throwing '..tostring(attacker)..", "..tostring(offset))
		if attacker and offset then
			local pos = self.inst:GetPosition()
			local facing_angle = attacker.Transform:GetRotation()*DEGREES
			local offset_vec = Vector3(offset.x * math.cos( facing_angle ), offset.y, -offset.x * math.sin( facing_angle ))
			print("facing", facing_angle)
			print("offset", offset)
			print("vec", offset_vec)
			pos = pos + offset_vec
			self.inst.Transform:SetPosition( pos:Get() )
		elseif target and offset then
			local pos = self.inst:GetPosition()
			local facing_angle = target.Transform:GetRotation()*DEGREES
			local offset_vec = Vector3(offset.x * math.cos( facing_angle ), offset.y, -offset.x * math.sin( facing_angle ))
			print("facing", facing_angle)
			print("offset", offset)
			print("vec", offset_vec)
			pos = pos + offset_vec
			self.inst.Transform:SetPosition( pos:Get() )
		end
		if self.vertical then 
			 self.inst.Physics:SetVel(0, self.speed, 0)
		else 
			self:RotateToTarget(self.dest)
			self.inst.Physics:SetMotorVel(self.speed,0,0)
		end 
		self.inst:StartUpdatingComponent(self)
		self.inst:PushEvent("onthrown", {thrower = owner, target = target})
		target:PushEvent("hostileprojectile",{thrower = owner, attacker = attacker, target = target})
		if self.onthrown then
			self.onthrown(self.inst, owner, target)
		end
		if self.cancatch and target.components.catcher and target.prefab == "situyl" and target:HasTag("player") then
			target.components.catcher:StartWatching(self.inst)
		end
	end
	
	inst:AddComponent("equippable")
	inst.components.equippable:SetOnEquip( onequip )
	inst.components.equippable:SetOnUnequip( onunequip )

	return inst
end

return Prefab( "common/inventory/situyl_claw", basicfn, basic_assets)